import 'dart:io';

import 'package:_private_core_network/utils.dart';
import 'package:dio/dio.dart';
import 'package:_private_core/_private_core.dart';
import '../resources.dart';

class _MyAppEndpoint {
  _MyAppEndpoint._();
  static String createOrLoginPro() => "createOrLoginPro";
  static String updateNewUserPasswordByFirebase() =>
      "updateNewUserPasswordByFirebase";
  static String loginPro() => "loginPro";
  static String updateProFromSA() => "updateProFromSA";
  static String updateUserFromSA() => "updateUserFromSA";
  static String logoutPro() => "logoutPro";
  static String logoutUser() => "logoutUser";
  static String loginProCrmByQrCode() => 'loginProCrmByQrCode';
  static String getMaincatList() => "getMaincatList";
  static String getSubcatList() => "getSubcatList";
  static String getSpecList() => "getSpecList";
  static String getHashtagsList() => "getHashtagsList";
  static String getContactsList() => "getContactsList";
  static String addUserInContactsList() => "addUserInContactsList";
  static String addUserOrProToContactListByFirebaseId() =>
      "addUserOrProToContactListByFirebaseId";
  static String updateCommentForContact() => "updateCommentForContact";
  static String deleteContact() => "deleteContact";
  static String getAnythingFromQr() => "getAnythingFromQr";
  static String getExistingUserByPhone() => "getExistingUserByPhone";
  static String updateDelay() => "updateDelay";
  static String cancelTicketByPro() => "cancelTicketByPro";
  static String confirmTicketByPro() => "confirmTicketByPro";
  static String ticketUserNotResponse() => "ticketUserNotResponse";
  static String startTicket() => "startTicket";
  static String stopTicket() => "stopTicket";
  static String callNextTicket() => "callNextTicket";
  static String getAllServicesOfProFromPro() => "getAllServicesOfProFromPro";
  static String declareUserAsAbsentFromPro() => "declareUserAsAbsentFromPro";
  static String getServiceAvailabilityForMonth() =>
      "getServiceAvailabilityForMonth";
  static String getListTimeFramesByServiceForDay() =>
      "getListTimeFramesByServiceForDay";
  static String createTicketByPro() => "createTicketByPro";
  static String canceledByProAfterCallBack() => "canceledByProAfterCallBack";
  static String deleteEventsFromPro() => "deleteEventsFromPro";
  static String getProductCategories() => "getProductCategories";
  static String getStatusList() => "getStatusList";
  static String getProductsFromPro() => "getProductsFromPro";
  static String getProductOfProFromSA() => "getProductOfProFromSA";
  static String getProductOfUserFromSA() => "getProductOfUserFromSA";
  static String updateTerminalFromPro() => "updateTerminalFromPro";
  static String updateProduct() => "updateProduct";
  static String createOrLoginUser() => "createOrLoginUser";
  static String getResultsFromFilters() => "getResultsFromFilters";
  static String getResultsFromSearch() => "getResultsFromSearch";
  static String createPurchaseByCardOnFileStripe() =>
      "createPurchaseByCardOnFileStripe";
  static String addLocationForUser() => "addLocationForUser";
  static String getLocationFromUser() => "getLocationFromUser";
  static String removeLocationForUser() => "removeLocationForUser";
  static String setLocationDefault() => "setLocationDefault";
  static String updateLocationForUser() => "updateLocationForUser";
  static String getReviewsFromPro() => "getReviewsFromPro";
  static String addToFavourite() => "addToFavourite";
  static String removeFromFavourite() => "removeFromFavourite";
  static String getFavouriteForUser() => "getFavouriteForUser";
  static String getAllServicesOfProFromUser() => "getAllServicesOfProFromUser";
  static String addUserLikeToPublicEvent() => "addUserLikeToPublicEvent";
  static String addSeenSuggestionEventFromUser() =>
      "addSeenSuggestionEventFromUser";
  static String setFavoriteCatForUser() => "setFavoriteCatForUser";
  static String removeFavoriteCatForUser() => "removeFavoriteCatForUser";
  static String getLikedPublicEventsFromUser() =>
      "getLikedPublicEventsFromUser";
  static String getTicketListFromPublicEvent() =>
      "getTicketListFromPublicEvent";
  static String getFavoritePublicEventsCategoriesFromUser() =>
      "getFavoritePublicEventsCategoriesFromUser";
  static String getPublicEventsCategories() => "getPublicEventsCategories";
  static String getSuggestionEventsFromUser() => "getSuggestionEventsFromUser";
  static String getAllPublicEventsAroundMe() => "getAllPublicEventsAroundMe";
  static String getPublicEventsListFromUser() => "getPublicEventsListFromUser";
  static String getAllPublicEventsFromSearch() =>
      "getAllPublicEventsFromSearch";
  static String getAllServicesAroundMe() => "getAllServicesAroundMe";
  static String createTicketByUser() => "createTicketByUser";
  static String cancelTicketByUser() => "cancelTicketByUser";
  static String getQueueInfoFromUser() => "getQueueInfoFromUser";
  static String getNextTimeFrameForService() => "getNextTimeFrameForService";
  static String getAllowedFeaturesForOowooApp() =>
      'getAllowedFeaturesForOowooApp';
  static String confirmTicketByUser() => "confirmTicketByUser";
  static String ticketUserCallBack() => "ticketUserCallBack";
  static String deleteEventsFromUser() => "deleteEventsFromUser";
  static String becomeSeller() => "becomeSeller";
  static String updateImageForBecomeSeller() => "updateImageForBecomeSeller";
  static String quitSellerProgram() => "quitSellerProgram";
  static String recoverySellerProgram() => "recoverySellerProgram";
  static String bookFreeTicketForPublicEvents() =>
      "bookFreeTicketForPublicEvents";
  static String getTncOowooApp() => "getTncOowooApp";
  static String getTncOowooSeller() => "getTncOowooSeller";
  static String getMissionsFromSeller() => "getMissionsFromSeller";
  static String getOoBRPlacesAroundMe() => "getOoBRPlacesAroundMe";
  static String getOoBRPlacesByFilterValues() => "getOoBRPlacesByFilterValues";
  static String getOoBRPlaceInfoById() => "getOoBRPlaceInfoById";
  static String updateFilterValueForOobr() => "updateFilterValueForOobr";
  static String getPromotedVideosForBar() => "getPromotedVideosForBar";
  static String getPromotedVideosForOobrPlaces() =>
      "getPromotedVideosForOobrPlaces";
  static String getPromotedVideosForOoh() => "getPromotedVideosForOoh";
  static String getOoBRCategories() => "getOoBRCategories";
  static String getOoBRFilters() => "getOoBRFilters";
  static String checkBarGooglePlaceIdByContributor() =>
      "checkBarGooglePlaceIdByContributor";
  static String createNewOobrPlaceByContributor() =>
      "createNewOobrPlaceByContributor";
  static String addOobrPlaceToFavorites() => "addOobrPlaceToFavorites";
  static String getFavoriteOobrPlaces() => "getFavoriteOobrPlaces";
  static String getOobrPlaceSchedules() => "getOobrPlaceSchedules";
  static String getOobrPlaceMenuList() => "getOobrPlaceMenuList";
  static String getOobrPlaceMenuContent() => "getOobrPlaceMenuContent";
  static String getOptionsForItem() => "getOptionsForItem";
  static String getAllergensForItem() => "getAllergensForItem";
  static String createOrderForOobrPlace() => "createOrderForOobrPlace";
  static String getDetailOobrInvitations() => "getDetailOobrInvitations";
  static String inviteContactsToOobrPlace() => "inviteContactsToOobrPlace";
  static String answerOobrInvitation() => 'answerOobrInvitation';
  static String getEmergencyInfos() => 'getEmergencyInfos';
  static String sendEmergencyRequest() => 'sendEmergencyRequest';
  static String createSharedPcEvent() => 'createSharedPcEvent';
  static String setThumbnailForPcEvent() => 'setThumbnailForPcEvent';
  static String getPcEventFromUser() => 'getPcEventFromUser';
  static String whatsNext() => 'whatsNext';
  static String generateVideoCallToken() => 'generateVideoCallToken';
  static String getMissionTypes() => 'getMissionTypes';
  static String takeMissionFromSeller() => 'takeMissionFromSeller';
  static String getNumberOfSalesFromSellers() => 'getNumberOfSalesFromSellers';
  static String setBankAccountFromUser() => 'setBankAccountFromUser';
  static String getAccountTypes() => 'getAccountTypes';
  static String getBankInfosFromSeller() => 'getBankInfosFromSeller';
  static String updateBankInfosFromSeller() => 'updateBankInfosFromSeller';
  static String getTrackingInfosForMeeting() => 'getTrackingInfosForMeeting';
  static String addUserOrProToTrackingPeople() =>
      'addUserOrProToTrackingPeople';
  static String updateTrackingInfosForMeeting() =>
      'updateTrackingInfosForMeeting';
  static String getLearnMoreTrackingVideo() => 'getLearnMoreTrackingVideo';
  static String getReminderTypes() => 'getReminderTypes';
  static String getOowooMoveProperties() => 'getOowooMoveProperties';
  static String getOowooVideoByTypeId() => 'getOowooVideoByTypeId';
  static String getCalmCategories() => 'getCalmCategories';
  static String getCalmByCat() => 'getCalmByCat';
  static String getSubscribersForCalmId() => 'getSubscribersForCalmId';
  static String subscribeToCalmId() => 'subscribeToCalmId';
  static String testSendNotificationToUser() => 'testSendNotificationToUser';
  static String testSendNotificationToPro() => 'testSendNotificationToPro';
  static String notifVideoCallUserFromPro() => 'notifVideoCallUserFromPro';
  static String notifVideoCallProFromUser() => 'notifVideoCallProFromUser';
  static String getCategoriesList() => 'getCategoriesList';
  static String resetProPassword() => 'resetProPassword';
  static String getInfoByUsername() => "getInfoByUsername";
  static String updateHomelidoMeeting() => 'updateHomelidoMeeting';
  static String getTerminalsFromPro() => "getTerminalsFromPro";
  static String setMainLanguageForPro() => "setMainLanguageForPro";
  static String setLanguagesForPro() => "setLanguagesForPro";
  static String getPcEventFromPro() => "getPcEventFromPro";
  static String linkTerminalToProV2() => 'linkTerminalToProV2';

  static String getAssetsForProFromUniversalDashboard() =>
      "getAssetsForProFromUniversalDashboard";
  static String getIndustriesList() => "getIndustriesList";
  static String v2_getPlaylistFromPro() => "v2_getPlaylistFromPro";
  static String v2_createPlaylistFromPro() => "v2_createPlaylistFromPro";
  static String v2_deletePlaylistFromPro() => "v2_deletePlaylistFromPro";
  static String v2_getItemContentFromPlaylist() =>
      "v2_getItemContentFromPlaylist";
  static String v2_addItemToPlaylist() => "v2_addItemToPlaylist";
  static String v2_removeItemFromPlaylist() => "v2_removeItemFromPlaylist";
  static String v2_getPlaylistsFromTerminal() => "v2_getPlaylistsFromTerminal";
  static String v2_sendPlaylistToTerminal() => "v2_sendPlaylistToTerminal";
  static String getPmbDevicesAroundMe() => 'getPmbDevicesAroundMe';
  static String scanDeviceQr() => 'scanDeviceQr';
  static String activatePourDevice() => 'activatePourDevice';
  static String getHistoryFromUser() => 'getHistoryFromUser';
  static String getCurrencyAvailableForToken() =>
      'getCurrencyAvailableForToken';
  static String getCurrentTokenValue() => 'getCurrentTokenValue';
  static String getWalletInfo() => "getWalletInfo";
  static String getBgVideo() => 'getBgVideo';
  static String checkAndAddNewContact() => 'checkAndAddNewContact';
  static String getPlacesFromPro() => "getPlacesFromPro";
  static String getPlaceCatByLang() => "getPlaceCatByLang";
  static String createPlace() => "createPlace";
  static String updatePlace() => "updatePlace";
  static String deletePlace() => "deletePlace";
  static String v2_getProblemTypesList() => "v2_getProblemTypesList";
  static String getFaqGroupsFromPlatformId() => "getFaqGroupsFromPlatformId";
  static String getProblemTypesForGroupId() => "getProblemTypesForGroupId";
  static String clickOnFaq() => "clickOnFaq";
  static String getFaqForProblemType() => "getFaqForProblemType";
  static String v2_getMyTicketsFromCustomer() => "v2_getMyTicketsFromCustomer";
  static String v2_postTicketByCustomer() => "v2_postTicketByCustomer";
  static String v2_getMyTicketsFromAgent() => 'v2_getMyTicketsFromAgent';
  static String v2_answerToTicketFromAgent() => 'v2_answerToTicketFromAgent';
  static String v2_answerToTicketFromCustomer() =>
      'v2_answerToTicketFromCustomer';
  static String getAnswersOfTicket() => 'getAnswersOfTicket';
  static String v2_getAgentList() => 'v2_getAgentList';
  static String v2_assignTicketToAgents() => 'v2_assignTicketToAgents';
  static String getLinksListFromMainLink() => "getLinksListFromMainLink";
  static String getCategoriesFromEventsWebsite() =>
      "getCategoriesFromEventsWebsite";
  static String getResultsByCatFromEventsWebsite() =>
      "getResultsByCatFromEventsWebsite";
  static String getAllEventsFromEventsWebsite() =>
      "getAllEventsFromEventsWebsite";
  static String createFirebaseDynamicLink() => "createFirebaseDynamicLink";
  static String getVideoPlaylistsFromTerminal() =>
      "getVideoPlaylistsFromTerminal";
  static String getServicesListFromTerminal() => "getServicesListFromTerminal";
  static String getNextTicketAvailableForQueueFromTerminal() =>
      "getNextTicketAvailableForQueueFromTerminal";
  static String cancelNextTicketAvailableForQueueFromTerminal() =>
      "cancelNextTicketAvailableForQueueFromTerminal";
  static String getListOfRoles() => "getListOfRoles";
  static String setProRole() => "setProRole";
  static String getListOfProsFromAdmin() => "getListOfProsFromAdmin";
  static String getListOfUsersFromAdmin() => "getListOfUsersFromAdmin";
  static String getAllTerminalFromAdmin() => "getAllTerminalFromAdmin";
  static String v2_linkPlaylistToTerminalForPro() =>
      "v2_linkPlaylistToTerminalForPro";
  static String v2_getCurrentTerminalsOfPlaylistFromPro() =>
      "v2_getCurrentTerminalsOfPlaylistFromPro";
  static String v2_addScheduleForPlaylist() => "v2_addScheduleForPlaylist";
  static String v2_updateScheduleForPlaylist() =>
      "v2_updateScheduleForPlaylist";
  static String v2_removeScheduleForPlaylist() =>
      "v2_removeScheduleForPlaylist";
  static String v2_updateOrderItemsFromPlaylist() =>
      "v2_updateOrderItemsFromPlaylist";
  static String v2GetProductCategories() => "v2GetProductCategories";
  static String v2getProductRefByCatId() => "v2getProductRefByCatId";
  static String getProInfosFromSA() => "getProInfosFromSA";
  static String getUserInfosFromSA() => "getUserInfosFromSA";
  static String setKisblePublicThumbnailForPro() =>
      "setKisblePublicThumbnailForPro";
  static String setThumbnailForProFromSA() => "setThumbnailForProFromSA";
  static String setThumbnailForUserFromSA() => "setThumbnailForUserFromSA";
  static String getPaymentMethodList() => "getPaymentMethodList";
  static String getPaymentStatusList() => "getPaymentStatusList";
  static String getOrdersFromProOrUser() => "getOrdersFromProOrUser";
  static String getOrdersFromAdmin() => "getOrdersFromAdmin";
  static String updateOrderDetailsByAdmin() => "updateOrderDetailsByAdmin";
  static String getBillingInfosFromProOrUser() =>
      "getBillingInfosFromProOrUser";
  static String getBillingInfosFromPro() => "getBillingInfosFromPro";
  static String updateBillingInfosFromProOrUser() =>
      "updateBillingInfosFromProOrUser";
  static String deleteBillingInfosFromProOrUser() =>
      "deleteBillingInfosFromProOrUser";
  static String addBillingInfosFromProOrUser() =>
      "addBillingInfosFromProOrUser";
  static String setDefaultBillingInfos() => "setDefaultBillingInfos";
  static String createMovieCollection() => "createMovieCollection";
  static String updateMovieCollection() => "updateMovieCollection";
  static String getMyMovieCollections() => "getMyMovieCollections";
  static String addMovieInArckipelDb() => "addMovieInArckipelDb";
  static String addMovieBookmarksToCollection() =>
      "addMovieBookmarksToCollection";
  static String removeMovieFromCollection() => "removeMovieFromCollection";
  static String getMyBookmarks() => "getMyBookmarks";
  static String updateMyMovieInfos() => "updateMyMovieInfos";
  static String getAccountOwnershipFromPro() =>
      "v2/common/getAccountOwnershipFromPro";
  static String createNewFirebaseCustomToken() =>
      "createNewFirebaseCustomToken";
  static String getMqttInfo() => "getMqttInfo";
}

abstract class AppApi {
  /// Auth
  Future<NetworkResponse> createOrLoginPro(params);
  Future<NetworkResponse> createOrLoginUser(params);
  Future<NetworkResponse> updateProFromSA(params);
  Future<NetworkResponse> updateUserFromSA(params);
  Future<NetworkResponse> updateNewUserPasswordByFirebase(params);
  Future<NetworkResponse> logoutPro(params);
  Future<NetworkResponse> logoutUser(params);
  Future<NetworkResponse> loginPro(params);
  Future<NetworkResponse> loginProCrmByQrCode(params);
  Future<NetworkResponse> getCategoriesList();
  Future<NetworkResponse> getInfoByUsername(username);
  Future<NetworkResponse> getAssetsForProFromUniversalDashboard(proUniqueId);
  Future<NetworkResponse> getIndustriesList();

  /// Core
  Future<NetworkResponse> getAllowedFeaturesForOowooApp();
  Future<NetworkResponse> getTncOowooApp();
  Future<NetworkResponse> getTncOowooSeller();
  Future<NetworkResponse> testSendNotificationToUser(params);
  Future<NetworkResponse> testSendNotificationToPro(params);
  Future<NetworkResponse> notifVideoCallUserFromPro(params);
  Future<NetworkResponse> notifVideoCallProFromUser(params);

  ///Contacts
  Future<NetworkResponse> getContactsList(params);
  Future<NetworkResponse> addUserInContactsList(params);
  Future<NetworkResponse> addUserOrProToContactListByFirebaseId(params);
  Future<NetworkResponse> updateCommentForContact(params);
  Future<NetworkResponse> deleteContact(params);
  Future<NetworkResponse> getExistingUserByPhone(params);
  Future<NetworkResponse> checkAndAddNewContact(params);

  ///My products
  Future<NetworkResponse> getProductCategories();
  Future<NetworkResponse> getStatusList();
  Future<NetworkResponse> getProductsFromPro(params);
  Future<NetworkResponse> getProductOfProFromSA(params);
  Future<NetworkResponse> getProductOfUserFromSA(params);
  Future<NetworkResponse> updateTerminalFromPro(params);
  Future<NetworkResponse> updateProduct(params);
  Future<NetworkResponse> linkTerminalToProV2(params);
  Future<NetworkResponse> getAllTerminalFromAdmin(params);
  Future<NetworkResponse> v2_getCurrentTerminalsOfPlaylistFromPro(params);

  ///PublicEvents
  Future<NetworkResponse> getAllPublicEventsAroundMe(params);
  Future<NetworkResponse> getPublicEventsListFromUser(params);
  Future<NetworkResponse> getPublicEventsCategories(languageCode);
  Future<NetworkResponse> getFavoritePublicEventsCategoriesFromUser(
      languageCode);
  Future<NetworkResponse> getSuggestionEventsFromUser(params);
  Future<NetworkResponse> getAllPublicEventsFromSearch(params);
  Future<NetworkResponse> getLikedPublicEventsFromUser();
  Future<NetworkResponse> addUserLikeToPublicEvent(publicEventId);
  Future<NetworkResponse> setFavoriteCatForUser(catId);
  Future<NetworkResponse> removeFavoriteCatForUser(catId);
  Future<NetworkResponse> addSeenSuggestionEventFromUser(
      publicEventId, utcModifier);
  Future<NetworkResponse> bookFreeTicketForPublicEvents(proUniqueId);
  Future<NetworkResponse> getTicketListFromPublicEvent(publicEventId);

  ///Payments
  // Future<NetworkResponse> getPurchaseStripe(params);
  // Future<NetworkResponse> getPurchasesStripe(params);

  //Locations
  Future<NetworkResponse> addLocationForUser(params);
  Future<NetworkResponse> getLocationFromUser(params);
  Future<NetworkResponse> removeLocationForUser(params);
  Future<NetworkResponse> setLocationDefault(params);
  Future<NetworkResponse> updateLocationForUser(params);

  //Filter events/services
  Future<NetworkResponse> getMaincatList(params);
  Future<NetworkResponse> getCategoriesFromEventsWebsite(params);
  Future<NetworkResponse> getResultsByCatFromEventsWebsite(params);
  Future<NetworkResponse> getAllEventsFromEventsWebsite(params);
  Future<NetworkResponse> getSubcatList(params);
  Future<NetworkResponse> getSpecList(params);
  Future<NetworkResponse> getHashtagsList(params);
  Future<NetworkResponse> getResultsFromFilters(params);
  Future<NetworkResponse> getResultsFromSearch(params);

  ///Sellers
  Future<NetworkResponse> becomeSeller(confirmed);
  Future<NetworkResponse> updateImageForBecomeSeller(fileType, file,
      [ProgressCallback? callback]);
  Future<NetworkResponse> quitSellerProgram(temp);
  Future<NetworkResponse> recoverySellerProgram();
  Future<NetworkResponse> getMissionsFromSeller(params);
  Future<NetworkResponse> getMissionTypes(params);
  Future<NetworkResponse> takeMissionFromSeller(missionId);
  Future<NetworkResponse> getNumberOfSalesFromSellers(params);
  Future<NetworkResponse> setBankAccountFromUser(params);
  Future<NetworkResponse> getAccountTypes();
  Future<NetworkResponse> getBankInfosFromSeller();
  Future<NetworkResponse> updateBankInfosFromSeller(params);

  ///Other
  // https://byabbe.se/on-this-day/3/18/events.json
  // https://byabbe.se/on-this-day/3/18/births.json
  // https://byabbe.se/on-this-day/3/18/deaths.json
  Future<NetworkResponse> eventsOnThisDay(date);
  Future<NetworkResponse> birthsOnThisDay(date);
  Future<NetworkResponse> deathsOnThisDay(date);
  Future<NetworkResponse> pexelsSearch(params);
  //Weather
  Future<NetworkResponse> weatherForecast(params);
  Future<NetworkResponse> weatherHistory(params);

  //Movies
  Future<NetworkResponse> themoviedbSearchMovie(params);
  Future<NetworkResponse> themoviedbSearchPerson(params);
  Future<NetworkResponse> themoviedbSearchKeyword(params);
  Future<NetworkResponse> themoviedbSearchMulti(params);
  Future<NetworkResponse> themoviedbMovieDetail(id, params);
  Future<NetworkResponse> themoviedbMovieDetailCredits(id, params);
  Future<NetworkResponse> themoviedbMovieDetailImages(id, params);
  Future<NetworkResponse> themoviedbMovieDetailVideos(id, params);
  Future<NetworkResponse> themoviedbMovieDetailSimilar(id, params);
  Future<NetworkResponse> themoviedbMovieReview(id, params);
  Future<NetworkResponse> themoviedbTrending(mediaType, timeWindow, params);
  Future<NetworkResponse> themoviedbDiscoverMovie(params);
  Future<NetworkResponse> themoviedbGenres(params);
  Future<NetworkResponse> themoviedbPersonDetail(id, params);
  Future<NetworkResponse> themoviedbPersonDetailImages(id, params);
  Future<NetworkResponse> themoviedbPersonCredits(id, params);
  Future<NetworkResponse> themoviedbConfigLanguage(params);
  // Future<NetworkResponse> themoviedb(params);
  Future<NetworkResponse> createMovieCollection(params);
  Future<NetworkResponse> updateMovieCollection(params);
  Future<NetworkResponse> getMyMovieCollections(params);
  Future<NetworkResponse> addMovieInArckipelDb(params);
  Future<NetworkResponse> addMovieBookmarksToCollection(params);
  Future<NetworkResponse> removeMovieFromCollection(params);
  Future<NetworkResponse> getMyBookmarks(params);
  Future<NetworkResponse> updateMyMovieInfos(params);

  //Bars restaurants
  Future<NetworkResponse> getOoBRPlacesAroundMe(params);
  Future<NetworkResponse> getOoBRPlacesByFilterValues(params);
  Future<NetworkResponse> getFavoriteOobrPlaces();
  Future<NetworkResponse> getOoBRPlaceInfoById(params);
  Future<NetworkResponse> updateFilterValueForOobr(params);
  Future<NetworkResponse> getPromotedVideosForBar(oobrPlaceId);
  Future<NetworkResponse> getPromotedVideosForOobrPlaces(lat, lng);
  Future<NetworkResponse> getOoBRCategories(languageCode);
  Future<NetworkResponse> getOoBRFilters(languageCode);
  Future<NetworkResponse> checkBarGooglePlaceIdByContributor(googlePlaceId);
  Future<NetworkResponse> createNewOobrPlaceByContributor(params);
  Future<NetworkResponse> addOobrPlaceToFavorites(oobrPlaceId);
  Future<NetworkResponse> getOobrPlaceSchedules(oobrPlaceId);
  Future<NetworkResponse> getOobrPlaceMenuList(oobrPlaceId, languageCode);
  Future<NetworkResponse> getOobrPlaceMenuContent(menuId, languageCode);
  Future<NetworkResponse> getOptionsForItem(itemId, languageCode);
  Future<NetworkResponse> getAllergensForItem(itemId, languageCode);
  Future<NetworkResponse> createOrderForOobrPlace(params);
  Future<NetworkResponse> getAnythingFromQr(params);
  Future<NetworkResponse> getDetailOobrInvitations(oobrEventId);
  Future<NetworkResponse> inviteContactsToOobrPlace(params);
  Future<NetworkResponse> answerOobrInvitation(params);

  ///Emergency
  Future<NetworkResponse> getEmergencyInfos(params);
  Future<NetworkResponse> sendEmergencyRequest(params);

  ///PersonalEvents
  Future<NetworkResponse> createSharedPcEvent(params);
  Future<NetworkResponse> setThumbnailForPcEvent(path, pcEventId);
  Future<NetworkResponse> shareCalendarToUsers(params);
  Future<NetworkResponse> getPcEventFromUser(pcEventId);
  Future<NetworkResponse> getPcEventFromPro(pcEventId);

  ///Home
  Future<NetworkResponse> getHomesAroundMe(params);
  Future<NetworkResponse> getPromotedVideosForOoh(lat, lng);

  ///Whatnext
  Future<NetworkResponse> whatsNext(params);
  Future<NetworkResponse> getReminderTypes();
//Agora
  Future<NetworkResponse> generateToken(channelName, expiredTime);
//Tracking position
  Future<NetworkResponse> getTrackingInfosForMeeting(params);
  Future<NetworkResponse> addUserOrProToTrackingPeople(params);
  Future<NetworkResponse> updateTrackingInfosForMeeting(params);
  Future<NetworkResponse> getLearnMoreTrackingVideo();
//Move
  Future<NetworkResponse> getOowooMoveProperties(params);
  Future<NetworkResponse> getOowooVideoByTypeId(typeId);
//Relax
  Future<NetworkResponse> getCalmCategories();
  Future<NetworkResponse> getCalmByCat(params);
  Future<NetworkResponse> subscribeToCalmId(calmId);
  Future<NetworkResponse> getSubscribersForCalmId(params);
//Agora
  Future<NetworkResponse> getReviewsFromPro(proId);
//Appointment
  Future<NetworkResponse> getQueueInfoFromUser(ticketUniqueId);
  Future<NetworkResponse> cancelTicketByUser(ticketUniqueId, status, comment);
  Future<NetworkResponse> confirmTicketByUser(ticketUniqueId, status, comment);
  Future<NetworkResponse> ticketUserCallBack(ticketUniqueId, duration);
  Future<NetworkResponse> deleteEventsFromUser(ticketUniqueId);
//Others
  Future<NetworkResponse> getFavouriteForUser();
  Future<NetworkResponse> removeFromFavourite(proId);
  Future<NetworkResponse> addToFavourite(proId);
  Future<NetworkResponse> getPlacesFromPro(params);
  Future<NetworkResponse> getPlaceCatByLang(params);
  Future<NetworkResponse> createPlace(params);
  Future<NetworkResponse> updatePlace(params);
  Future<NetworkResponse> deletePlace(params);
//Pro zone
  Future<NetworkResponse> setMainLanguageForPro(proLanguageCode);
  Future<NetworkResponse> setLanguagesForPro(proLanguageCode);
// Appointment
  Future<NetworkResponse> getAllServicesOfProFromPro(params);
  Future<NetworkResponse> updateDelay(params);
  Future<NetworkResponse> cancelTicketByPro(ticketUniqueId);
  Future<NetworkResponse> confirmTicketByPro(ticketUniqueId, status, comment);
  Future<NetworkResponse> declareUserAsAbsentFromPro(ticketUniqueId);
  Future<NetworkResponse> ticketUserNotResponse(ticketUniqueId);
  Future<NetworkResponse> startTicket(ticketUniqueId);
  Future<NetworkResponse> stopTicket(ticketUniqueId);
  Future<NetworkResponse> canceledByProAfterCallBack(ticketUniqueId);
  Future<NetworkResponse> callNextTicket(serviceId);
  Future<NetworkResponse> getListTimeFramesByServiceForDay(
      dateToday, serviceId);
  Future<NetworkResponse> getServiceAvailabilityForMonth(params);
  Future<NetworkResponse> createTicketByPro(params);
  Future<NetworkResponse> deleteEventsFromPro(ticketUniqueId);
  Future<NetworkResponse> createTicketByUser(params);
  Future<NetworkResponse> getAllServicesOfProFromUser(params);
  Future<NetworkResponse> getAllServicesAroundMe(params);
//Playlist
  Future<NetworkResponse> v2_getPlaylistFromPro(params);
  Future<NetworkResponse> v2_createPlaylistFromPro(params);
  Future<NetworkResponse> v2_deletePlaylistFromPro(params);
  Future<NetworkResponse> v2_getItemContentFromPlaylist(params);
  Future<NetworkResponse> v2_addItemToPlaylist(params);
  Future<NetworkResponse> v2_removeItemFromPlaylist(params);
  Future<NetworkResponse> v2_getPlaylistsFromTerminal(params);
  Future<NetworkResponse> v2_linkPlaylistToTerminalForPro(params);
  Future<NetworkResponse> v2_addScheduleForPlaylist(params);
  Future<NetworkResponse> v2_updateScheduleForPlaylist(params);
  Future<NetworkResponse> v2_removeScheduleForPlaylist(params);
  Future<NetworkResponse> v2_updateOrderItemsFromPlaylist(params);

  ///History pmb
  Future<NetworkResponse> getHistoryFromUser();

  ///pmb
  Future<NetworkResponse> getBgVideo(countryCode);
  Future<NetworkResponse> getPmbDevicesAroundMe(params);
  Future<NetworkResponse> scanDeviceQr(params);
  Future<NetworkResponse> activatePourDevice(deviceId);
  Future<NetworkResponse> ipAPI();
  Future<NetworkResponse> getCurrencyAvailableForToken(tokenType);
  Future<NetworkResponse> getCurrentTokenValue(tokenType, {currency = 'EUR'});
  Future<NetworkResponse> v2_getProblemTypesList(params);
  Future<NetworkResponse> getFaqForProblemType(params);
  Future<NetworkResponse> v2_getMyTicketsFromCustomer(params);
  Future<NetworkResponse> v2_postTicketByCustomer(params);
  Future<NetworkResponse> getFaqGroupsFromPlatformId(params);
  Future<NetworkResponse> getProblemTypesForGroupId(params);
  Future<NetworkResponse> clickOnFaq(params);
  Future<NetworkResponse> v2_getMyTicketsFromAgent(ticketStatusId);
  Future<NetworkResponse> v2_answerToTicketFromAgent(params);
  Future<NetworkResponse> v2_answerToTicketFromCustomer(params);
  Future<NetworkResponse> getAnswersOfTicket(ticketId);
  Future<NetworkResponse> v2_getAgentList();
  Future<NetworkResponse> v2_assignTicketToAgents(params);
  Future<NetworkResponse> getLinksListFromMainLink(params);
  Future<NetworkResponse> createFirebaseDynamicLink(params);
  Future<NetworkResponse> getVideoPlaylistsFromTerminal(params);
  Future<NetworkResponse> getServicesListFromTerminal();
  Future<NetworkResponse> getNextTicketAvailableForQueueFromTerminal(id);
  Future<NetworkResponse> cancelNextTicketAvailableForQueueFromTerminal(id);
  Future<NetworkResponse> getListOfRoles(params);
  Future<NetworkResponse> setProRole(params);
  Future<NetworkResponse> getListOfProsFromAdmin(params);
  Future<NetworkResponse> getListOfUsersFromAdmin(params);
  Future<NetworkResponse> v2GetProductCategories(params);
  Future<NetworkResponse> v2getProductRefByCatId(params);
  Future<NetworkResponse> getProInfosFromSA(params);
  Future<NetworkResponse> getUserInfosFromSA(params);
  Future<NetworkResponse> setKisblePublicThumbnailForPro(bytes, path, proId);
  Future<NetworkResponse> setThumbnailForProFromSA(bytes, path, proId);
  Future<NetworkResponse> setThumbnailForUserFromSA(bytes, path, proId);

  Future<NetworkResponse> getPaymentMethodList(params);
  Future<NetworkResponse> getPaymentStatusList(params);
  Future<NetworkResponse> getOrdersFromProOrUser(params);
  Future<NetworkResponse> getOrdersFromAdmin(params);
  Future<NetworkResponse> updateOrderDetailsByAdmin(params);

  Future<NetworkResponse> getAccountOwnershipFromPro(params);
  Future<NetworkResponse> createNewFirebaseCustomToken();
  Future<NetworkResponse> getMqttInfo();
  // Future<NetworkResponse> _____(params);
  // Future<NetworkResponse> _____(params);
  // Future<NetworkResponse> _____(params);
  // Future<NetworkResponse> _____(params);
  // Future<NetworkResponse> _____(params);
  // Future<NetworkResponse> _____(params);
  // Future<NetworkResponse> _____(params);
  // Future<NetworkResponse> _____(params);
}

class AppApiImp extends AppApi {
  @override
  Future<NetworkResponse> getAccountOwnershipFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.getAccountOwnershipFromPro(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> createOrLoginPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .post(_MyAppEndpoint.createOrLoginPro(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TokenResponseLogin.fromJson(json), prefix: '');
      },
    );
  }

  @override
  Future<NetworkResponse> updateNewUserPasswordByFirebase(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().post(
            _MyAppEndpoint.updateNewUserPasswordByFirebase(),
            data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> createOrLoginUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .post(_MyAppEndpoint.createOrLoginUser(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TokenResponseLogin.fromJson(json), prefix: '');
      },
    );
  }

  @override
  Future<NetworkResponse> createNewFirebaseCustomToken() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
          _MyAppEndpoint.createNewFirebaseCustomToken(),
        );
        return NetworkResponse.fromResponse(response,
            converter: (json) => json);
      },
    );
  }

  @override
  Future<NetworkResponse> getMqttInfo() async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response =
            await AppClient(token: token).get(_MyAppEndpoint.getMqttInfo());
        return NetworkResponse.fromResponse(response,
            converter: (json) => TokenResponseLoginMqtt.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> updateProFromSA(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .put(_MyAppEndpoint.updateProFromSA(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> updateUserFromSA(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .put(_MyAppEndpoint.updateUserFromSA(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> logoutPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .post(_MyAppEndpoint.logoutPro(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> logoutUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .post(_MyAppEndpoint.logoutUser(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getCategoriesList() async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getCategoriesList(),
            queryParameters: {'catLanguageCode': null});
        return NetworkResponse.fromResponse(
          response,
          converter: (json) => (json['maincats'] as List)
              .map((e) => MainCat.fromJson(e))
              .toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> loginPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient().post(_MyAppEndpoint.loginPro(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TokenResponseLogin.fromJson(json), prefix: '');
      },
    );
  }

  @override
  Future<NetworkResponse> loginProCrmByQrCode(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .post(_MyAppEndpoint.loginProCrmByQrCode(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TokenResponseLogin.fromJson(json), prefix: '');
      },
    );
  }

  @override
  Future<NetworkResponse> getInfoByUsername(username) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getInfoByUsername(),
            queryParameters: {'username': username});
        return NetworkResponse.fromResponse(response,
            converter: (json) => CommonUserModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getAssetsForProFromUniversalDashboard(
      proUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getAssetsForProFromUniversalDashboard(),
            queryParameters: {'proUniqueId': proUniqueId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => OrgProInfo.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getIndustriesList() async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getIndustriesList(),
            queryParameters: {'languageCode': appPrefs.languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<IndustryModel>((i) => IndustryModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getAllTerminalFromAdmin(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getAllTerminalFromAdmin(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => Terminal.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getCurrentTerminalsOfPlaylistFromPro(
      params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.v2_getCurrentTerminalsOfPlaylistFromPro(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => Terminal.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> updateTerminalFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateTerminalFromPro(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> updateProduct(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateProduct(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> takeMissionFromSeller(missionId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.takeMissionFromSeller(),
                data: {'missionId': missionId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getProductCategories() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getProductCategories(),
                queryParameters: {'display': 1});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProductCategory>((i) => ProductCategory.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getProductsFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getProductsFromPro(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProductModel>((i) => ProductModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getProductOfProFromSA(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getProductOfProFromSA(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProductModel>((i) => ProductModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getProductOfUserFromSA(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getProductOfUserFromSA(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProductModel>((i) => ProductModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getStatusList() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getStatusList());
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProductStatus>((i) => ProductStatus.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getAllPublicEventsFromSearch(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getAllPublicEventsFromSearch(),
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PublishEvent>((i) => PublishEvent.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getAllPublicEventsAroundMe(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getAllPublicEventsAroundMe(),
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PublishEvent>((i) => PublishEvent.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getPublicEventsListFromUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getPublicEventsListFromUser(),
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PublishEvent>((i) => PublishEvent.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getSuggestionEventsFromUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getSuggestionEventsFromUser(),
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PublishEvent>((i) => PublishEvent.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getPublicEventsCategories(languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getPublicEventsCategories(),
            queryParameters: {'languageCode': languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PublishEventCategory>(
                    (i) => PublishEventCategory.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getFavoritePublicEventsCategoriesFromUser(
      languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getFavoritePublicEventsCategoriesFromUser(),
            queryParameters: {'languageCode': languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PublishEventCategory>(
                    (i) => PublishEventCategory.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getLikedPublicEventsFromUser() async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .get(_MyAppEndpoint.getLikedPublicEventsFromUser());
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PublishEvent>((i) => PublishEvent.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getTicketListFromPublicEvent(publicEventId) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getTicketListFromPublicEvent(),
            queryParameters: {'publicEventId': publicEventId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<TicketInfoModel>((i) => TicketInfoModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> addUserLikeToPublicEvent(publicEventId) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).post(
            _MyAppEndpoint.addUserLikeToPublicEvent(),
            data: {'publicEventId': publicEventId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> setFavoriteCatForUser(catId) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).post(
            _MyAppEndpoint.setFavoriteCatForUser(),
            data: {'catId': catId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> removeFavoriteCatForUser(catId) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).delete(
            _MyAppEndpoint.removeFavoriteCatForUser(),
            data: {'catId': catId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> addSeenSuggestionEventFromUser(
      publicEventId, utcModifier) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).post(
            _MyAppEndpoint.addSeenSuggestionEventFromUser(),
            data: {'publicEventId': publicEventId, 'utcModifier': utcModifier});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> bookFreeTicketForPublicEvents(
      arckipelTicketId) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).post(
            _MyAppEndpoint.bookFreeTicketForPublicEvents(),
            data: {'arckipelTicketId': arckipelTicketId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getAllowedFeaturesForOowooApp() async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .get(_MyAppEndpoint.getAllowedFeaturesForOowooApp());
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<AllowedFeatureModel>(
                    (i) => AllowedFeatureModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> becomeSeller(confirmed) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).post(
            _MyAppEndpoint.becomeSeller(),
            data: {'confirmed': confirmed});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> updateImageForBecomeSeller(fileType, path,
      [ProgressCallback? callback]) async {
    return await handleNetworkError(
      proccess: () async {
        String fileName = path.split('/').last;
        FormData formData = FormData.fromMap({
          "fileType": fileType,
          "fileName": MultipartFile.fromBytes(File(path).readAsBytesSync(),
              filename: fileName),
        });
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).post(
            _MyAppEndpoint.updateImageForBecomeSeller(),
            data: formData,
            onSendProgress: callback);
        return NetworkResponse.fromResponse(response,
            value: response.data['values']['fileName']);
      },
    );
  }

  @override
  Future<NetworkResponse> quitSellerProgram(temporary) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).post(
            _MyAppEndpoint.quitSellerProgram(),
            data: {'temporary': temporary});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> recoverySellerProgram() async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .post(_MyAppEndpoint.recoverySellerProgram());
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getTncOowooApp() async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getTncOowooApp(),
            queryParameters: {'languageCode': appPrefs.languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['text']);
      },
    );
  }

  @override
  Future<NetworkResponse> getTncOowooSeller() async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getTncOowooSeller(),
            queryParameters: {'languageCode': appPrefs.languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['text']);
      },
    );
  }

  @override
  Future<NetworkResponse> birthsOnThisDay(date) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .get('https://byabbe.se/on-this-day/$date/births.json');
        return NetworkResponse.fromResponse(response,
            prefix: 'births',
            converter: (json) => (json as List<dynamic>)
                .map<OnThisDayModel>((i) => OnThisDayModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> deathsOnThisDay(date) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .get('https://byabbe.se/on-this-day/$date/deaths.json');
        return NetworkResponse.fromResponse(response,
            prefix: 'deaths',
            converter: (json) => (json as List<dynamic>)
                .map<OnThisDayModel>((i) => OnThisDayModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> eventsOnThisDay(date) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .get('https://byabbe.se/on-this-day/$date/events.json');
        return NetworkResponse.fromResponse(response,
            prefix: 'events',
            converter: (json) => (json as List<dynamic>)
                .map<OnThisDayModel>((i) => OnThisDayModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> pexelsSearch(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                isAuthorizationCustom: true, token: PEXEL_API_KEY)
            .get('https://api.pexels.com/v1/search', queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'photos',
            converter: (json) => (json as List<dynamic>)
                .map<PexelPhotoModel>((i) => PexelPhotoModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> weatherForecast(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.weatherapi.com/v1/forecast.json',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'forecast',
            converter: (json) => WeatherForecast.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> weatherHistory(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.weatherapi.com/v1/history.json',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'forecast',
            converter: (json) => WeatherForecast.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getMissionsFromSeller(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getMissionsFromSeller(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<SellerMissionModel>((i) => SellerMissionModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getMissionTypes(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getMissionTypes(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<MissionTypeModel>((i) => MissionTypeModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOoBRPlaceInfoById(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOoBRPlaceInfoById(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => BrPlaceModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getOoBRPlacesAroundMe(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOoBRPlacesAroundMe(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPlaceModel>((i) => BrPlaceModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOoBRPlacesByFilterValues(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOoBRPlacesByFilterValues(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPlaceModel>((i) => BrPlaceModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getFavoriteOobrPlaces() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getFavoriteOobrPlaces());
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPlaceModel>((i) => BrPlaceModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> updateFilterValueForOobr(params) async {
    return await handleNetworkError(proccess: () async {
      Response response =
          await AppClient(token: await appPrefs.getNormalToken())
              .post(_MyAppEndpoint.updateFilterValueForOobr(), data: params);
      return NetworkResponse.fromResponse(response,
          converter: (json) => json['updateFilterValueForOobr']);
    }, builder: (e) {
      if (e.response != null &&
          e.response!.statusCode == 400 &&
          e.response!.data != null) {
        return NetworkResponse.fromResponse(e.response!,
            value: e.response!.data['error']);
      }
    });
  }

  @override
  Future<NetworkResponse> getPromotedVideosForBar(oobrPlaceId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getPromotedVideosForBar(),
                queryParameters: {'oobrPlaceId': oobrPlaceId});
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List<dynamic>).map<String>((i) => i).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getPromotedVideosForOobrPlaces(lat, lng) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getPromotedVideosForOobrPlaces(),
                queryParameters: {'lat': lat, 'lng': lng});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPromotedVideoModel>(
                    (i) => BrPromotedVideoModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getPromotedVideosForOoh(lat, lng) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getPromotedVideosForOoh(),
                queryParameters: {'lat': lat, 'lng': lng});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPromotedVideoModel>(
                    (i) => BrPromotedVideoModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOoBRCategories(languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOoBRCategories(),
                queryParameters: {'languageCode': languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPlaceCateModel>((i) => BrPlaceCateModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOoBRFilters(languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOoBRFilters(),
                queryParameters: {'languageCode': languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPlaceFilterModel>((i) => BrPlaceFilterModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> checkBarGooglePlaceIdByContributor(
      googlePlaceId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.checkBarGooglePlaceIdByContributor(),
                queryParameters: {'googlePlaceId': googlePlaceId});
        return NetworkResponse.fromResponse(response, value: '');
      },
      builder: (e) {
        if (e.response != null &&
            e.response!.statusCode == 400 &&
            e.response!.data != null) {
          return NetworkResponse.fromResponse(e.response!,
              value: e.response!.data['oobrPlaceId']);
        }
        return NetworkResponse.withErrorRequest(e);
      },
    );
  }

  @override
  Future<NetworkResponse> createNewOobrPlaceByContributor(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.createNewOobrPlaceByContributor(),
                data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> addOobrPlaceToFavorites(oobrPlaceId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.addOobrPlaceToFavorites(),
                data: {'oobrPlaceId': oobrPlaceId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getOobrPlaceSchedules(oobrPlaceId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOobrPlaceSchedules(),
                queryParameters: {'oobrPlaceId': oobrPlaceId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPlaceScheduleModel>(
                    (i) => BrPlaceScheduleModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOobrPlaceMenuList(
      oobrPlaceId, languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getOobrPlaceMenuList(), queryParameters: {
          'oobrPlaceId': oobrPlaceId,
          'languageCode': languageCode
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<BrPlaceMenu>((i) => BrPlaceMenu.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOobrPlaceMenuContent(
      oobrPlaceId, languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOobrPlaceMenuContent(),
                queryParameters: {
              'oobrPlaceId': oobrPlaceId,
              'languageCode': languageCode
            });
        return NetworkResponse.fromResponse(response,
            converter: (json) => BrPlaceMenuContent.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getOptionsForItem(itemId, languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getOptionsForItem(), queryParameters: {
          'itemId': itemId,
          'languageCode': languageCode
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PlaceMenuItemOption>(
                    (i) => PlaceMenuItemOption.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getAllergensForItem(itemId, languageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getAllergensForItem(), queryParameters: {
          'itemId': itemId,
          'languageCode': languageCode
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PlaceMenuAllergens>((i) => PlaceMenuAllergens.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getContactsList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getContactsList(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ContactModel>((i) => ContactModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> addUserInContactsList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.addUserInContactsList(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => ContactModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> addUserOrProToContactListByFirebaseId(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.addUserOrProToContactListByFirebaseId(),
                data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => ContactModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> createFirebaseDynamicLink(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient()
            .post(_MyAppEndpoint.createFirebaseDynamicLink(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => json);
      },
    );
  }

  @override
  Future<NetworkResponse> deleteContact(id) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .delete(_MyAppEndpoint.deleteContact(), data: {'id': id});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> updateCommentForContact(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateCommentForContact(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getExistingUserByPhone(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getExistingUserByPhone(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => ContactModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> createOrderForOobrPlace(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.createOrderForOobrPlace(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<UserModel>((i) => UserModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getAnythingFromQr(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getAnythingFromQr(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => QrDataModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getDetailOobrInvitations(oobrEventId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getDetailOobrInvitations(),
                queryParameters: {'oobrEventId': oobrEventId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => BrPlaceInviteModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> inviteContactsToOobrPlace(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.inviteContactsToOobrPlace(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> answerOobrInvitation(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.answerOobrInvitation(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getEmergencyInfos(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getEmergencyInfos(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => EmergencyResult.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> sendEmergencyRequest(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.sendEmergencyRequest(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> createSharedPcEvent(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.createSharedPcEvent(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['id']);
      },
    );
  }

  @override
  Future<NetworkResponse> getPcEventFromUser(pcEventId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getPcEventFromUser(),
                queryParameters: {'pcEventId': pcEventId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => PeEventModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> setThumbnailForPcEvent(path, pcEventId) async {
    return await handleNetworkError(
      proccess: () async {
        String fileName = path.split('/').last;
        FormData data = FormData.fromMap({
          'pcEventId': pcEventId,
          "fileName": MultipartFile.fromBytes(File(path).readAsBytesSync(),
              filename: fileName),
        });
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.setThumbnailForPcEvent(), data: data);
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['fileName']);
      },
    );
  }

  @override
  Future<NetworkResponse> shareCalendarToUsers(params) =>
      throw UnimplementedError();

  @override
  Future<NetworkResponse> whatsNext(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.whatsNext(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => WhatNextModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> generateToken(channelName, expiredTime) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.generateVideoCallToken(),
                data: {'channel': channelName});
        return NetworkResponse.fromResponse(response,
            converter: (json) => AgoraToken.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getNumberOfSalesFromSellers(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getNumberOfSalesFromSellers(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => NumberOfSaleModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> setBankAccountFromUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.setBankAccountFromUser(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => BankAccountModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> updateBankInfosFromSeller(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateBankInfosFromSeller(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => BankAccountModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getAccountTypes() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getAccountTypes());
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => BankAccountTypeModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getBankInfosFromSeller() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getBankInfosFromSeller());
        return NetworkResponse.fromResponse(response,
            converter: (json) => BankAccountModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> addUserOrProToTrackingPeople(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.addUserOrProToTrackingPeople(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => TrackingInfoModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getTrackingInfosForMeeting(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getTrackingInfosForMeeting(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => TrackingInfoModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> updateTrackingInfosForMeeting(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .put(_MyAppEndpoint.updateTrackingInfosForMeeting(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => TrackingInfoModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getLearnMoreTrackingVideo() async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getLearnMoreTrackingVideo(),
            queryParameters: {'languageCode': appPrefs.languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => json);
      },
    );
  }

  @override
  Future<NetworkResponse> getReminderTypes() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getReminderTypes(),
                queryParameters: {'languageCode': appPrefs.languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => ReminderType.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOowooMoveProperties(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOowooMoveProperties(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => MoveModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getOowooVideoByTypeId(typeId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getOowooVideoByTypeId(), queryParameters: {
          'typeId': typeId,
          'languageCode': appPrefs.languageCode
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => VideoUrl.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getCalmByCat(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getCalmByCat(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<CalmModel>((i) => CalmModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getCalmCategories() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getCalmCategories(),
                queryParameters: {'languageCode': appPrefs.languageCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<CalmCate>((i) => CalmCate.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getSubscribersForCalmId(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getSubscribersForCalmId(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json['subscribers'] as List<dynamic>)
                .map<CalmSubscriber>((i) => CalmSubscriber.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> subscribeToCalmId(calmId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.subscribeToCalmId(), data: {'calmId': calmId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> testSendNotificationToPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.testSendNotificationToPro(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> testSendNotificationToUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.testSendNotificationToUser(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> notifVideoCallProFromUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.notifVideoCallProFromUser(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> notifVideoCallUserFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.notifVideoCallUserFromPro(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getReviewsFromPro(proId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getReviewsFromPro(),
                queryParameters: {'proId': proId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ReviewModel>((i) => ReviewModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> cancelTicketByUser(
      ticketUniqueId, status, comment) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.cancelTicketByUser(),
                data: {'ticketUniqueId': ticketUniqueId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> confirmTicketByUser(
      ticketUniqueId, status, comment) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.confirmTicketByUser(), data: {
          'ticketUniqueId': ticketUniqueId,
          'status': status,
          'comment': comment
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => TicketInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> deleteEventsFromUser(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .delete(_MyAppEndpoint.deleteEventsFromUser(), data: {
          'events': [ticketUniqueId]
        });
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getQueueInfoFromUser(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getQueueInfoFromUser(), queryParameters: {
          'catLanguageCode': appPrefs.languageCode,
          'ticketUniqueId': ticketUniqueId
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => EventQueueModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> ticketUserCallBack(ticketUniqueId, duration) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.ticketUserCallBack(),
                data: {'ticketUniqueId': ticketUniqueId, 'duration': duration});
        return NetworkResponse.fromResponse(response,
            converter: (json) => TicketInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> addToFavourite(proId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.addToFavourite(), data: {'proId': proId});
        return NetworkResponse.fromResponse(response, value: true);
      },
    );
  }

  @override
  Future<NetworkResponse> getFavouriteForUser() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getFavouriteForUser());
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProsModel>((i) => ProsModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> removeFromFavourite(proId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).delete(
                _MyAppEndpoint.removeFromFavourite(),
                data: {'proId': proId});
        return NetworkResponse.fromResponse(response, value: true);
      },
    );
  }

  @override
  Future<NetworkResponse> getPcEventFromPro(pcEventId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getPcEventFromPro(),
                queryParameters: {'pcEventId': pcEventId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => PeEventModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> linkTerminalToProV2(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.linkTerminalToProV2(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getPlacesFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getPlacesFromPro());
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => PlaceModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> createPlace(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.createPlace(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => PlaceModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> updatePlace(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updatePlace(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> deletePlace(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .delete(_MyAppEndpoint.deletePlace(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getPlaceCatByLang(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getPlaceCatByLang(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => PlaceCatModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> setLanguagesForPro(proLanguageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.setLanguagesForPro(),
                data: {'proLanguageCode': proLanguageCode});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> setMainLanguageForPro(proLanguageCode) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.setMainLanguageForPro(),
                data: {'proLanguageCode': proLanguageCode});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getAllServicesOfProFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getAllServicesOfProFromPro(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => ProServiceModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> callNextTicket(serviceId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.callNextTicket(),
                data: {'serviceId': serviceId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => TicketInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> cancelTicketByPro(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.cancelTicketByPro(),
                data: {'ticketUniqueId': ticketUniqueId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> canceledByProAfterCallBack(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.canceledByProAfterCallBack(),
                data: {'ticketUniqueId': ticketUniqueId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => EventInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> confirmTicketByPro(
      ticketUniqueId, status, comment) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.confirmTicketByPro(), data: {
          'ticketUniqueId': ticketUniqueId,
          'confirm': status,
          'comment': comment
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => EventInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> createTicketByPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.createTicketByPro(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TicketInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getAllServicesOfProFromUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getAllServicesOfProFromUser(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => ProServicesBusiness.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getAllServicesAroundMe(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getAllServicesAroundMe(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => ServicesAroundMeModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> createTicketByUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.createTicketByUser(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TicketInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> declareUserAsAbsentFromPro(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.declareUserAsAbsentFromPro(),
                data: {'ticketUniqueId': ticketUniqueId});
        return NetworkResponse.fromResponse(response,
            converter: (json) => EventInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> deleteEventsFromPro(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .delete(_MyAppEndpoint.deleteEventsFromPro(), data: {
          'events': [ticketUniqueId]
        });
        return NetworkResponse.fromResponse(response,
            converter: (json) => EventInfoModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getListTimeFramesByServiceForDay(
      dateToday, serviceId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getListTimeFramesByServiceForDay(),
                queryParameters: {
              'dateToday': dateToday,
              'serviceId': serviceId
            });
        return NetworkResponse.fromResponse(response,
            converter: (json) => ListTimeFrameModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getServiceAvailabilityForMonth(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getServiceAvailabilityForMonth(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => ServiceAvailabilityModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> startTicket(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.startTicket(),
                data: {'ticketUniqueId': ticketUniqueId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> stopTicket(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.stopTicket(),
                data: {'ticketUniqueId': ticketUniqueId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> ticketUserNotResponse(ticketUniqueId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.ticketUserNotResponse(),
                data: {'ticketUniqueId': ticketUniqueId});
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> updateDelay(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.updateDelay(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => ServiceDelayModel.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> activatePourDevice(deviceId) async {
    return await handleNetworkError(proccess: () async {
      Response response =
          await AppClient(token: await appPrefs.getNormalToken()).post(
              _MyAppEndpoint.activatePourDevice(),
              data: {'deviceId': deviceId});
      return NetworkResponse.fromResponse(response,
          value: response.statusCode == 200);
    }, builder: (e) {
      if (e.response?.statusCode == 400) {
        return NetworkResponse.fromResponse(e.response!,
            value: e.response!.data['error']);
      }
      return NetworkResponse.withErrorRequest(e);
    });
  }

  @override
  Future<NetworkResponse> getBgVideo(countryCode) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getBgVideo(),
            queryParameters: {'countryCode': countryCode});
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['videoUrl']);
      },
    );
  }

  @override
  Future<NetworkResponse> getCurrencyAvailableForToken(tokenType) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getCurrencyAvailableForToken(),
            queryParameters: {'tokenType': tokenType});
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List<dynamic>).map<String>((i) => i).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getCurrentTokenValue(tokenType,
      {currency = 'EUR'}) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getCurrentTokenValue(),
            queryParameters: {'tokenType': tokenType, 'currency': currency});
        return NetworkResponse.fromResponse(response,
            converter: (json) => double.parse(json.toString()));
      },
    );
  }

  @override
  Future<NetworkResponse> getHistoryFromUser() async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .get(_MyAppEndpoint.getHistoryFromUser());
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<History>((i) => History.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getPmbDevicesAroundMe(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.getPmbDevicesAroundMe(),
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PmbDevice>((i) => PmbDevice.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> ipAPI() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(baseUrl: 'http://ip-api.com/').get('json');
        return NetworkResponse.fromResponse(response,
            converter: (json) => IpInfo.fromJson(json), prefix: '');
      },
    );
  }

  @override
  Future<NetworkResponse> scanDeviceQr(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .get(_MyAppEndpoint.scanDeviceQr(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => ScanQr.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> checkAndAddNewContact(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .post(_MyAppEndpoint.checkAndAddNewContact(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_addItemToPlaylist(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.v2_addItemToPlaylist(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => PlaylistItemModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> v2_createPlaylistFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.v2_createPlaylistFromPro(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => PlaylistModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> v2_deletePlaylistFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .delete(_MyAppEndpoint.v2_deletePlaylistFromPro(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getItemContentFromPlaylist(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.v2_getItemContentFromPlaylist(),
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PlaylistItemModel>((i) => PlaylistItemModel.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getPlaylistFromPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token).get(
            _MyAppEndpoint.v2_getPlaylistFromPro(),
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<PlaylistModel>((i) => PlaylistModel.fromJson(i))
                .toList());
      },
    );
  }

  // @override
  // Future<NetworkResponse> v2_getPlaylistsFromTerminal(params) async {
  //   bool isDisconnect = await WifiService.isDisconnectWhenCallApi();
  //   if (isDisconnect) return NetworkResponse.withDisconnect();
  //   try {
  //     final token = await appPrefs.getNormalToken();
  //     Response response = await AppClients( token: token)
  //         .get(AppEndpoint.v2_getPlaylistsFromTerminal(),
  //             queryParameters:params);
  //     return NetworkResponse.fromResponse(response,
  //         converter: (json) => (json as List<dynamic>)
  //             .map<PlaylistModel>((i) => PlaylistModel.fromJson(i))
  //             .toList());
  //   } , builder: (e)  {
  //     return NetworkResponse.withErrorRequest(e);
  //   } catch (e) {
  //     return NetworkResponse.withErrorConvert(e);
  //   }
  // }

  @override
  Future<NetworkResponse> v2_removeItemFromPlaylist(params) async {
    return await handleNetworkError(
      proccess: () async {
        final token = await appPrefs.getNormalToken();
        Response response = await AppClient(token: token)
            .delete(_MyAppEndpoint.v2_removeItemFromPlaylist(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_linkPlaylistToTerminalForPro(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
                _MyAppEndpoint.v2_linkPlaylistToTerminalForPro(),
                data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_addScheduleForPlaylist(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.v2_addScheduleForPlaylist(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_updateScheduleForPlaylist(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .put(_MyAppEndpoint.v2_updateScheduleForPlaylist(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_removeScheduleForPlaylist(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).delete(
                _MyAppEndpoint.v2_removeScheduleForPlaylist(),
                data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_updateOrderItemsFromPlaylist(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).put(
                _MyAppEndpoint.v2_updateOrderItemsFromPlaylist(),
                data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getProblemTypesList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.v2_getProblemTypesList(),
                queryParameters: params);

        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProblemType>((i) => ProblemType.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getFaqGroupsFromPlatformId(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getFaqGroupsFromPlatformId(),
                queryParameters: params);

        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<FaqGroup>((i) => FaqGroup.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> clickOnFaq(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.clickOnFaq(), queryParameters: params);

        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProblemType>((i) => ProblemType.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getProblemTypesForGroupId(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getProblemTypesForGroupId(),
                queryParameters: params);

        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<ProblemType>((i) => ProblemType.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getFaqForProblemType(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getFaqForProblemType(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List<dynamic>)
                .map<FaqItem>((i) => FaqItem.fromJson(i))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getMyTicketsFromCustomer(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.v2_getMyTicketsFromCustomer(),
                queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
          prefix: '',
          converter: (json) => ListTicket.fromJson(json),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> v2_postTicketByCustomer(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.v2_postTicketByCustomer(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TicketDetail.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getMyTicketsFromAgent(ticketStatusId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.v2_getMyTicketsFromAgent(), queryParameters: {
          'languageCode': appPrefs.languageCode,
          'ticketStatusId': ticketStatusId,
        });
        return NetworkResponse.fromResponse(
          response,
          prefix: '',
          converter: (json) => ListTicket.fromJson(json),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getAgentList() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.v2_getAgentList(), queryParameters: {
          'languageCode': appPrefs.languageCode,
        });
        return NetworkResponse.fromResponse(
          response,
          converter: (json) =>
              (json as List).map((e) => AgentModel.fromJson(e)).toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> v2_answerToTicketFromAgent(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.v2_answerToTicketFromAgent(), data: params);
        return NetworkResponse.fromResponse(
          response,
          value: response.statusCode == 200,
        );
      },
    );
  }

  @override
  Future<NetworkResponse> v2_answerToTicketFromCustomer(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.v2_answerToTicketFromCustomer(), data: params);
        return NetworkResponse.fromResponse(
          response,
          value: response.statusCode == 200,
        );
      },
    );
  }

  @override
  Future<NetworkResponse> v2_assignTicketToAgents(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.v2_assignTicketToAgents(), data: params);
        return NetworkResponse.fromResponse(
          response,
          value: response.statusCode == 200,
        );
      },
    );
  }

  @override
  Future<NetworkResponse> getAnswersOfTicket(ticketId) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getAnswersOfTicket(), queryParameters: {
          'ticketId': ticketId,
        });
        return NetworkResponse.fromResponse(
          response,
          converter: (json) =>
              (json as List).map((e) => TicketAnswer.fromJson(e)).toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> getLinksListFromMainLink(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient().get(
            _MyAppEndpoint.getLinksListFromMainLink(),
            queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
          converter: (json) => MainLink.fromJson(json),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> addLocationForUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.addLocationForUser(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => LocationModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getAllEventsFromEventsWebsite(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getAllEventsFromEventsWebsite(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => PublishEvent.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getCategoriesFromEventsWebsite(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getCategoriesFromEventsWebsite(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => PublishEventCategory.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getHashtagsList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getHashtagsList(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => HashTagModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getLocationFromUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getLocationFromUser(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => LocationModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getMaincatList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getMaincatList(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => MainCatModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getResultsByCatFromEventsWebsite(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getResultsByCatFromEventsWebsite(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => PublishEvent.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getResultsFromFilters(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getResultsFromFilters(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => ProsModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getResultsFromSearch(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getResultsFromSearch(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => ProsModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getSpecList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getSpecList(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => SpecCatModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getSubcatList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getSubcatList(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => SubCatModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> removeLocationForUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.removeLocationForUser(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> setLocationDefault(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.setLocationDefault(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> updateLocationForUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateLocationForUser(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getVideoPlaylistsFromTerminal(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getVideoPlaylistsFromTerminal(),
                queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
        );
      },
    );
  }

  @override
  Future<NetworkResponse> getServicesListFromTerminal() async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getServicesListFromTerminal());
        return NetworkResponse.fromResponse(response,
            converter: (json) => QueueOowooModel.listFromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getNextTicketAvailableForQueueFromTerminal(id) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
          _MyAppEndpoint.getNextTicketAvailableForQueueFromTerminal(),
          queryParameters: {'serviceId': id},
        );
        return NetworkResponse.fromResponse(response,
            converter: (json) => TicketModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> cancelNextTicketAvailableForQueueFromTerminal(
      id) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).post(
          _MyAppEndpoint.cancelNextTicketAvailableForQueueFromTerminal(),
          data: {'ticketUniqueId': id},
        );
        return NetworkResponse.fromResponse(
          response,
          value: response.data,
        );
      },
    );
  }

  @override
  Future<NetworkResponse> v2_getPlaylistsFromTerminal(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.v2_getPlaylistsFromTerminal());
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => PlaylistModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getListOfProsFromAdmin(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getListOfProsFromAdmin(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => ProInfo.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getProInfosFromSA(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getProInfosFromSA(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => ProInfo.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getUserInfosFromSA(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getUserInfosFromSA(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => UserModel.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getListOfRoles(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getListOfRoles(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => RolePro.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getListOfUsersFromAdmin(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getListOfUsersFromAdmin(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) =>
                (json as List).map((e) => UserModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> setProRole(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.setProRole(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> v2GetProductCategories(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.v2GetProductCategories(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => ProductCategory.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> v2getProductRefByCatId(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.v2getProductRefByCatId(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => ProductReference.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> setKisblePublicThumbnailForPro(
      bytes, path, proId) async {
    return await handleNetworkError(
      proccess: () async {
        String fileName = path.split('/').last;
        FormData data = FormData.fromMap({
          'proId': proId,
          "fileName": MultipartFile.fromBytes(bytes, filename: fileName),
        });
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.setKisblePublicThumbnailForPro(), data: data);
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['fileName']);
      },
    );
  }

  @override
  Future<NetworkResponse> setThumbnailForProFromSA(bytes, path, proId) async {
    return await handleNetworkError(
      proccess: () async {
        String fileName = path.split('/').last;
        FormData data = FormData.fromMap({
          'proId': proId,
          "fileName": MultipartFile.fromBytes(bytes, filename: fileName),
        });
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.setThumbnailForProFromSA(), data: data);
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['fileName']);
      },
    );
  }

  @override
  Future<NetworkResponse> setThumbnailForUserFromSA(bytes, path, proId) async {
    return await handleNetworkError(
      proccess: () async {
        String fileName = path.split('/').last;
        FormData data = FormData.fromMap({
          'proId': proId,
          "fileName": MultipartFile.fromBytes(bytes, filename: fileName),
        });
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.setThumbnailForUserFromSA(), data: data);
        return NetworkResponse.fromResponse(response,
            converter: (json) => json['fileName']);
      },
    );
  }

  @override
  Future<NetworkResponse> getPaymentMethodList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getPaymentMethodList(),
                queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
          converter: (json) =>
              (json as List).map((e) => PaymentMethod.fromJson(e)).toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> getPaymentStatusList(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getPaymentStatusList(),
                queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
          converter: (json) =>
              (json as List).map((e) => PaymentStatus.fromJson(e)).toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> getOrdersFromProOrUser(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getOrdersFromProOrUser(),
                queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
          converter: (json) =>
              (json as List).map((e) => PaymentOrder.fromJson(e)).toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> getOrdersFromAdmin(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .get(_MyAppEndpoint.getOrdersFromAdmin(), queryParameters: params);
        return NetworkResponse.fromResponse(
          response,
          converter: (json) =>
              (json as List).map((e) => PaymentOrder.fromJson(e)).toList(),
        );
      },
    );
  }

  @override
  Future<NetworkResponse> updateOrderDetailsByAdmin(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateOrderDetailsByAdmin(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbSearchMulti(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/search/multi',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMovieModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbSearchPerson(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/search/person',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMoviePerson.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbSearchMovie(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/search/movie',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMovieModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbMovieDetail(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/movie/$id',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: '', converter: (json) => TheMovieDetail.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbMovieReview(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/movie/$id/reviews',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMovieReview.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbTrending(
      mediaType, timeWindow, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/trending/$mediaType/$timeWindow',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMovieModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbDiscoverMovie(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/discover/movie',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMovieModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbGenres(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/genre/movie/list',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'genres',
            converter: (json) => (json as List)
                .map((e) => TheMovieDetailGenres.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbMovieDetailCredits(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/movie/$id/credits',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: '', converter: (json) => TheMovieCredit.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbMovieDetailImages(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/movie/$id/images',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: '', converter: (json) => TheMovieImage.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbMovieDetailVideos(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/movie/$id/videos',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMovieVideo.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbPersonDetail(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/person/$id',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: '',
            converter: (json) => TheMoviePersonDetail.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbPersonCredits(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/person/$id/movie_credits',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: '',
            converter: (json) => TheMoviePersonCredit.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbPersonDetailImages(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/person/$id/images',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: '',
            converter: (json) => TheMoviePersonImage.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbMovieDetailSimilar(id, params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/movie/$id/similar',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) =>
                (json as List).map((e) => TheMovieModel.fromJson(e)).toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbSearchKeyword(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/search/keyword',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: 'results',
            converter: (json) => (json as List)
                .map((e) => TheMovieKeyword.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> themoviedbConfigLanguage(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
          enableErrorHandler: false,
        ).get('https://api.themoviedb.org/3/configuration/languages',
            queryParameters: params);
        return NetworkResponse.fromResponse(response,
            prefix: '',
            converter: (json) => (json as List)
                .map((e) => TheMovieLanguage.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> createMovieCollection(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.createMovieCollection(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TheMovieCollection.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> addMovieBookmarksToCollection(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .post(_MyAppEndpoint.addMovieBookmarksToCollection(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> removeMovieFromCollection(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response = await AppClient(
                token: await appPrefs.getNormalToken())
            .delete(_MyAppEndpoint.removeMovieFromCollection(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> addMovieInArckipelDb(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .post(_MyAppEndpoint.addMovieInArckipelDb(), data: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => TmmAddToArckipelResult.fromJson(json));
      },
    );
  }

  @override
  Future<NetworkResponse> getMyBookmarks(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .get(_MyAppEndpoint.getMyBookmarks(), queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => TheMovieBookmark.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> getMyMovieCollections(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken()).get(
                _MyAppEndpoint.getMyMovieCollections(),
                queryParameters: params);
        return NetworkResponse.fromResponse(response,
            converter: (json) => (json as List)
                .map((e) => TheMovieCollection.fromJson(e))
                .toList());
      },
    );
  }

  @override
  Future<NetworkResponse> updateMovieCollection(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateMovieCollection(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> updateMyMovieInfos(params) async {
    return await handleNetworkError(
      proccess: () async {
        Response response =
            await AppClient(token: await appPrefs.getNormalToken())
                .put(_MyAppEndpoint.updateMyMovieInfos(), data: params);
        return NetworkResponse.fromResponse(response,
            value: response.statusCode == 200);
      },
    );
  }

  @override
  Future<NetworkResponse> getHomesAroundMe(params) {
    // TODO: implement getHomesAroundMe
    throw UnimplementedError();
  }
}
