class UploadThumbnalResult {
  int? id;
  String? displayName;
  String? uuid;
  String? thumbnail;

  UploadThumbnalResult({this.id, this.displayName, this.uuid, this.thumbnail});

  UploadThumbnalResult.fromJson(Map<String, dynamic> json) {
    id = json["id"];
    displayName = json["displayName"];
    uuid = json["uuid"];
    thumbnail = json["thumbnail"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data["id"] = id;
    data["displayName"] = displayName;
    data["uuid"] = uuid;
    data["thumbnail"] = thumbnail;
    return data;
  }
}
