class CommonUserModel {
  int? id;
  String? firebaseId;
  String? username;
  String? uniqueId;
  String? displayName;
  String? thumbnail;
  int? isPro;
  List<String>? fcmTokens;
  String? countryCode;

  CommonUserModel({
    this.id,
    this.firebaseId,
    this.username,
    this.uniqueId,
    this.displayName,
    this.thumbnail,
    this.isPro,
    this.fcmTokens,
    this.countryCode,
  });

  CommonUserModel.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    firebaseId = json['firebaseId'] ?? '';
    username = json['username'] ?? '';
    isPro = json['isPro'];
    uniqueId = json['uniqueId'];
    displayName = json['displayName'] ?? '';
    thumbnail = json['thumbnail'] ?? '';
    fcmTokens = json['fcmTokens'] ?? [];
    countryCode = json["countryCode"];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['id'] = id;
    data['firebaseId'] = firebaseId;
    data['username'] = username;
    data['isPro'] = isPro;
    data['uniqueId'] = uniqueId;
    data['displayName'] = displayName;
    data['thumbnail'] = thumbnail;
    data['fcmTokens'] = fcmTokens;
    data["countryCode"] = countryCode;
    return data;
  }
}
